#include "asm86.h"
#include "ti86asm.inc"

_pause		equ		$4D43
_runIndicOff    equ     $4AB1
_clrWindow      .equ    4A86h
_homeUp         .equ    4A95h
LNE		equ		018h
.org _asm_exec_ram
	nop
	jp		MainMenu
	.dw		0000
	.dw		ShellTitle
MainMenu:
	call _runIndicOff
	call _clrScrn
	call _homeup
	ld hl,ProgTitle
	call TopBigBlack
    	ld hl,$0800
	ld (_penCol),hl
	ld hl,AdjCon
	call _vputs
	ld hl,$0003
	ld (_curRow),hl
	ld hl,MyName
	call _puts
    	ld hl,$3900
	ld (_penCol),hl
	ld hl,FuncMenu
	call _vputs
	ld hl,$3200
	ld (_penCol),hl
	ld hl,QString
    	call _vputs
	call B7Black
GKL:	
	call _getkey
	cp kF5	
	jp z,Exit
	cp kF1
	jp z,F1Pressed
	cp kF2
	jp z,F2Pressed
	cp kAdd
	jp z,MoreCon
	cp kSub
	jp z,LessCon
	cp kF3
	jp z,F3Pressed
	cp kClear
	jp z,ClearandPause
	jr GKL	 
ClearandPause:
	call _runIndicOff
	call _clrLCD
	call _pause
	jp MainMenu
MoreCon:
	ld a,($C008)
	inc a
	ld ($C008),a
	Out (2),a
	jr GKL
LessCon:
	ld a,1
	ld a,($C008)
	dec a
	ld ($C008),a
	Out (2),a
	jr GKL
AdjCon:
	.db "+/- Adjust Contrast",0
ProgTitle:
	.db "Unit Circle Functions",0
FuncMenu:
    .db " Def.       "
    .db "U.Circle       "
    .db "Pythag        "
    .db "                "
    .db "   "
    .db "         Exit",0
MyName:
	.db "   By: Adam Martin    ",0
ShellTitle:
	.db "Unit Circle Helper v1.1",0
Exit:
	call _clrLCD
	ret
FuncTitle:
	.db "   Definition of Trigonometric Functions",0
QString:	
	.db "   What function do you need help with ?",0
XYEQUALS:
	.db " ",193," = Real # at (x,y) ",0
F1Pressed:
	call _clrScrn
	call _homeup
	ld hl,XYEQUALS
	call TopBigBlack
	ld hl,$3900
	ld (_penCol),hl
	ld hl,FuncTitle
	call _vputs
	call B7Black
DrawDef:
	ld hl,$1000
	ld (_penCol),hl
	ld hl,row1
	call _vputs
	ld hl,$1800
	ld (_penCol),hl
	ld hl,row2
	call _vputs
	ld hl,$2000
	ld (_penCol),hl
	ld hl,row3
	call _vputs
	call _pause
	jp MainMenu
ROW1:
	.db " 0               - 0",212,"           (1, 0)"0
ROW2:
	.db " ",Lpi,"/6     - 30",212,"       (",Lroot,"3/2, 1/2)",0
ROW3:
	.db " ",Lpi,"/4     - 45",212,"       (",Lroot,"2/2, ",Lroot,"2/2)",0
ROW4:
	.db " ",Lpi,"/3     - 60",212,"       (1/2, "Lroot,"3/2)",0
ROW5:
	.db " ",Lpi,"/2     - 90",212,"       (0, 1)",0
ROW6:
	.db " 2",Lpi,"/3 - 120",212,"   (-1/2, ",Lroot,"3/2)",0
ROW7:
	.db " 3",Lpi,"/4 - 135",212,"   (-",Lroot,"2/2, ",Lroot,"2/2)",0
ROW8:
	.db " 5",Lpi,"/6 - 150",212,"   (-",Lroot,"3/2, 1/2)",0
ROW9:
	.db " ",Lpi,"             - 180",212,"   (-1, 0)",0
ROW10:
	.db " 7",Lpi,"/6     - 210",212,"   (-",Lroot,"3/2, -1/2)",0
ROW11: 
	.db " 5",Lpi,"/4     - 225",212,"   (-",Lroot,"2/2, -",Lroot,"2/2)",0
ROW12:
	.db " 4",Lpi,"/3     - 240",212,"   (-1/2, -",Lroot,"3/2)",0
ROW13:
	.db " 3",Lpi,"/2     - 270",212,"   (0, -1)",0
ROW14:
	.db " 5",Lpi,"/3     - 300",212,"   (1/2, -",Lroot,"3/2)",0
ROW15:
	.db " 7",Lpi,"/4     - 315",212,"   (",Lroot,"2/2, -",Lroot,"2/2)",0
ROW16:
	.db " 11",Lpi,"/6 - 330",212,"   (",Lroot,"3/2, -1/2)",0
ROW17:
	.db " 2",Lpi,"             - 360",212,"   (1, 0)",0
row1:
	.db "    sin   ",193," = y                 "
	.db "                         cos ",193," = x",0
row2:
	.db "    tan ",193," = y/x,  x",LNE,"0               "
	.db "cot ",193," = x/y,  y",LNE,"0",0
row3:
	.db "    csc ",193," = 1/y,  y",LNE,"0               "
	.db "sec ",193," = 1/x,  y",LNE,"0",0
F2Title:
	.db "Rad            Deg           (x,y)                <Press Enter>",0
F2Pressed:
	call TopLitBlack
	    ld   hl,F2Title
	call Drw
	ld hl,$0700
	ld (_penCol),hl
	ld hl,ROW1
	call _vputs
	ld hl,$0E00
	ld (_penCol),hl
	ld hl,ROW2
	call _vputs
	ld hl,$1400
	ld (_penCol),hl
	ld hl,ROW3
	call _vputs
	ld hl,$1A00
	ld (_penCol),hl
	ld hl,ROW4
	call _vputs
	ld hl,$2000
	ld (_penCol),hl
	ld hl,ROW5
	call _vputs
	ld hl,$2600
	ld (_penCol),hl
	ld hl,ROW6
	call _vputs
	ld hl,$2D00
	ld (_penCol),hl
	ld hl,ROW7
	call _vputs
	ld hl,$3300
	ld (_penCol),hl
	ld hl,ROW8
	call _vputs
	ld hl,$3900
	ld (_penCol),hl
	ld hl,ROW9
	call _vputs
	call _pause		;**************2nd Screen
	call TopLitBlack
	ld   hl,F2Title
	call Drw
	ld hl,$0900
	ld (_penCol),hl
	ld hl,ROW10
	call _vputs
	ld hl,$0F00
	ld (_penCol),hl
	ld hl,ROW11
	call _vputs
	ld hl,$1500
	ld (_penCol),hl
	ld hl,ROW12
	call _vputs
	ld hl,$1B00
	ld (_penCol),hl
	ld hl,ROW13
	call _vputs
	ld hl,$2100
	ld (_penCol),hl
	ld hl,ROW14
	call _vputs
	ld hl,$2700
	ld (_penCol),hl
	ld hl,ROW15
	call _vputs
	ld hl,$2E00
	ld (_penCol),hl
	ld hl,ROW16
	call _vputs
	ld hl,$3400
	ld (_penCol),hl
	ld hl,ROW17
	call _vputs
	call _pause
	jp MainMenu
AngleTheta:
	.db Langle," ",193," - ",0

RecipID1:
	.db "sin",Lsquare,"u + cos",Lsquare,"u = 1",0
RecipID2:
	.db "1 + tan",Lsquare,"u = sec",Lsquare,"u",0
RecipID3:
	.db "1 + cot",Lsquare,"u = csc",Lsquare,"u",0
TRow1:
	.db "sin ",193," = b/c   ,   cos ",193," = a/c   ,   tan ",193," = b/a",0
TRow2:
	.db "csc ",193," = c/b   ,   sec ",193," = c/a   ,   cot ",193," = a/b",0
DispC:
	.db "c",0
DispB:
	.db "b",0
DispA:
	.db "a",0
pythag:
	.db "a",Lsquare," + b",Lsquare," = c",Lsquare,0
F3Title:
	.db "   Pythagorean Identities and Functions ",0
F3Pressed:
        call TopLitBlack
        ld hl,F3Title
	call Drw
	ld hl,$40
	ld (_penCol),hl
	ld hl,$07
	ld (_penRow),hl
	ld hl,pythag
	call _vputs	
	ld hl,$4A
	ld (_penCol),hl
	ld hl,$1C
	ld (_penRow),hl
	ld hl,AngleTheta
	call _vputs	
	ld hl,$63
	ld (_penCol),hl
	ld hl,$0F
	ld (_penRow),hl
	ld hl,DispC
	call _vputs
	ld hl,$78
	ld (_penCol),hl
	ld hl,$12
	ld (_penRow),hl
	ld hl,DispB
	call _vputs
	ld hl,$6A
	ld (_penCol),hl
	ld hl,$21
	ld (_penRow),hl
	ld hl,DispA
	call _vputs
	ld hl,$0700
	ld (_penCol),hl
	ld hl,RecipID1
	call _vputs
	ld hl,$00
	ld (_penCol),hl
	ld hl,$0E
	ld (_penRow),hl
	ld hl,RecipID2
	call _vputs
	ld hl,$00
	ld (_penCol),hl
	ld hl,$15
	ld (_penRow),hl
	ld hl,RecipID3
	call _vputs
	ld hl,$00
	ld (_penCol),hl
	ld hl,$2D
	ld (_penRow),hl
	ld hl,TRow1
	call _vputs
	ld hl,$00
	ld (_penCol),hl
	ld hl,$34
	ld (_penRow),hl
	ld hl,TRow2
	call _vputs
	ld b,118
	ld c,30
	ld d,118
	ld e,55
	ld h,1
	call _ILine
	ld d,93
	ld e,30
	call _ILine
	ld c,55
	call _ILine
	ld c,34
	ld d,114
	ld e,34
	call _ILine
	ld b,114
	ld c,30
	call _ILine
	ld b,58
	ld c,56
	ld d,58
	ld e,34
	call _ILine
	ld b,0
	ld c,34
	ld d,58
	call _ILine
	ld b,100
	ld c,30
	ld d,97
	ld e,34
	ld h,1
	call _ILine
	call _pause
	jp MainMenu

TopBigBlack:
	set 3,(iy+5)
	call _puts
	res 3,(iy+5)
	ret
B7Black:
    ld b,112
    ld hl,$FF90
Draw1:
    ld a,(hl)
    cpl
    ld (hl),a
    inc	hl
    djnz Draw1
	ret
TopLitBlack:
	call _clrLCD
	ld   hl,$FC00
    ld   (hl),$FF
    ld   de,$FC01
    ld   bc,111
    ldir
    set  3,(iy+05)
    ld   de,$0001
    ld   (_penCol),de
    ret
Drw:
    call _vputs
    res  3,(iy+05)
	ret